package org.conventionsframework.qualifier;

import static java.lang.annotation.ElementType.TYPE;
import static java.lang.annotation.ElementType.PARAMETER;
import static java.lang.annotation.ElementType.FIELD;
import static java.lang.annotation.ElementType.METHOD;
import java.lang.annotation.Retention;
import static java.lang.annotation.RetentionPolicy.RUNTIME;
import java.lang.annotation.Target;
import javax.enterprise.util.Nonbinding;
import javax.inject.Qualifier;

@Qualifier
@Retention(RUNTIME)
@Target({TYPE, FIELD, PARAMETER, METHOD})
public @interface Service {

    @Nonbinding
    String name() default "";

    @Nonbinding
    Class entity() default Byte.class;

    Type type() default Type.CUSTOM;
    
    public static final String STATELESS = "statelessHibernateService";
    public static final String STATEFUL = "statefulHibernateService";
    public static final String CUSTOM = "customHibernateService";
}
